/*
 * ======== Standard MSP430 includes ========
 */
#include <msp430.h>
#include<stdlib.h>
#include  <stdint.h>
/*
 * ======== Grace related includes ========
 */
#include <ti/mcu/msp430/Grace.h>


#define CMD  ((const unsigned char *)"CMD")
#define CONNECTED ((const unsigned char *)"Connected")
#define MLDP ((const unsigned char *)"MLDP")
#define AOK ((const unsigned char *)"AOK")
#define ERR ((const unsigned char *)"ERR")
#define CEND ((const unsigned char *)"Connection End")
#define START ((const unsigned char *)"STR")

#define CARROT ((const unsigned char *)">")
#define NODATA ((const unsigned char *)"NO DATA")
#define OK ((const unsigned char *)"OK")
#define STOPPED ((const unsigned char *)"STOPPED")
#define POWER ((const unsigned char *)"ELM327 v1.3")
#define SEARCH ((const unsigned char *)"SEARCHING...")

//void reqSTN(volatile unsigned char* OBDreq);

extern volatile unsigned char btque[], stnque[];
extern volatile unsigned int btfront, btrear, stnfront, stnrear;
extern volatile unsigned int isbtempty, isstnempty;
volatile unsigned char response[100];
volatile unsigned char STNresponse[100];
volatile unsigned char tmp;
volatile unsigned int i,j;
volatile unsigned int flag;


/*
 *  ======== main ========
 */
int main(void)
{
    Grace_init();                   // Activate Grace-generated configuration
    
   // >>>>> Fill-in user code here <<<<<
   // volatile unsigned int i;
//    __delay_cycles(100000);
//    	send_UART("SF,1",1);
//    	__delay_cycles(100000);
//        send_UART("SR,32000000",1); // from the app demo
//        __delay_cycles(100000);
//       __delay_cycles(100000);
//       __delay_cycles(100000);
//        send_UART("SS,F0000000",1);
//        send_UART("R,1",1);
//        __delay_cycles(100000);

//while(1)
//{
//
//
//    for(i = 0; i<700; i++)
//    {
//    	 for(j = 0; j<700; j++)
//    	    {
//    		 	 // ~2 second delay
//    	    }
//    }
//
//    send_UART("T1", 1);
//
//    for(i = 0; i<700; i++)
//    {
//    	 for(j = 0; j<700; j++)
//    	    {
//    		 	 // ~2 second delay
//    	    }
//    }
//
//    send_UART("T2", 1);
//
//    for(i = 0; i<700; i++)
//    {
//    	 for(j = 0; j<700; j++)
//    	    {
//    		 	 // ~2 second delay
//    	    }
//    }
//
//    send_UART("T3", 1);
//}
    // STN debug messages
//    stnque[0] = '>';
//    stnque[1] = '\r';
//    stnque[2] = '4';
//    stnque[3] = '1';
//    stnque[4] = '1';
//    stnque[5] = 'F';
//    stnque[6] = '0';
//    stnque[7] = '0';
//    stnque[8] = '0';
//    stnque[9] = '5';
//    stnque[10] = '\r';
//    stnque[11] = '>';
//    stnque[12] = '\r';

//
//        for(i = 0; i<700; i++)
//        {
//        	 for(j = 0; j<700; j++)
//        	    {
//        		 	 // ~2 second delay
//        	    }
//        }
//
//        send_UART("AT L0", 0);// linefeeds off

//        for(i = 0; i<700; i++)
//        {
//        	 for(j = 0; j<700; j++)
//        	    {
//        		 	 // ~2 second delay
//        	    }
//        }
//
    //STN power on initialization
		send_UART("AT L0", 0);// linefeeds off
		__delay_cycles(1000000);
		send_UART("AT E0", 0);// echo off
		__delay_cycles(1000000);
		send_UART("AT S0", 0);// spaces off
		__delay_cycles(1000000);
		send_UART("AT AL", 0);// allow long messages
		__delay_cycles(1000000);

		// flush buffer
		stnfront = stnrear;
		isstnempty =1;

//		send_UART("01 02",0); // engine RPM
//		__delay_cycles(1000000);
//		send_UART("01 0D",0); // speed km/h
//		__delay_cycles(1000000);
//		send_UART("01 10",0); // air flow rate in gm/s
//		__delay_cycles(1000000);
//		send_UART("01 2F",0); // fuel level input %


//        for(i = 0; i<700; i++)
//        {
//        	 for(j = 0; j<700; j++)
//        	    {
//        		 	 // ~2 second delay
//        	    }
//        }
//
//        send_UART("T1",1);
	send_UART("AT L0", 0);// linefeeds off
   __delay_cycles(100000);

    while(1)
      {

         while(isbtempty==1)
         {
             // do nothing
         }
         i=0;
         while(1)
         {
             if(isbtempty==1)
             {
                 continue;
             }
             // dequeue from btqueue
             tmp = btque[btfront];
             btfront++;
             if(btfront == 100)
            	 btfront =0; // wrap arround
             if(btfront == btrear)
            	 isbtempty =1; //queue has been emptied
             if(tmp == '\r')
             {
               // ignore carriage returns
               // this is an issue for now i-- but its better to strip
               // carriage returns from BT input buffer
               i--;
               // printf("Hit a carriage return BT\n");
             }
             else if(tmp == '\n' || tmp == 'Z')
             {
               response[i] = '\0'; // null terminate to end string
               // send_UART(response,1); //echo response debug- can't unless mldp
               //printf("Hit a terminate condition BT Added null term at %d\n",i);
               // i=0; // maybe this helps?, prob not needed
               break;
             }
             else
             {
               response[i] = tmp;
               //printf("Added %c to BTResponse at %d\n",response[i],i);
             }

             i++;
         }

         //printf("BT Response is: %s\n",response);

         if(strcmp((const unsigned char *)response, CMD)==0)
         {
             //printf("CMD response found\n");
        	 // send_UART("CMD received",1); //response debug- can't unless MLDP
             continue;
         }
         else if(strcmp((const unsigned char *)response, ERR)==0)
         {
        	 // send_UART("ERR received",1); //response debug- can't unless MLDP
           continue;
           //maybe want to set a flag here also
         }
         else if(strcmp((const unsigned char *)response, CEND)==0)
         {
           continue;
           //maybe want to set a flag here also
         }
         else if(strcmp((const unsigned char *)response, AOK)==0)
         {
           //send_UART("AOK received",1); //response debug- can't unless MLDP
           continue;
           //maybe want to set a flag here also
         }
         else if(strcmp((const unsigned char *)response, START)==0)
         {
        	 //ready to receive OBD commands
        	send_UART("RDY",1); //response debug -- further testing needed
        	 continue;
         }
         else if(strcmp((const unsigned char *)response, CONNECTED)==0)
         {
            //printf("Connected respond found\n");
        	 //send_UART("Connected",1); //response debug - can't unless MLDP
           continue;
           //maybe want to set a flag here also
         }
         else if(strcmp((const unsigned char *)response, MLDP)==0)
         {
            //printf("MLDP response found\n");
        	 send_UART("MLDP mode",1); //response debug
           continue;
           //maybe want to set a flag here also
         }
         else
         {
           // theoretically only thing left is an OBD req, but
           // might want to check for the Z, just in case
          // printf("Shipping %s to STN routine\n", response);
           //reqSTN(response);
           // now response should be in STNresponse
           //printf("Response from STN is: %s\n",STNresponse);
           //send this through BT uart to mobile device
           //continue on and wait for the next command

        	 // STN routine
        	 while(1)
        	   {
        	     while(isstnempty == 1)
        	     {
        	       // trap until a response is received
        	     }
        	     j=0;
        	     flag=0;
        	     while(1)
        	     {
        	         if(isstnempty == 1)
        	           {
        	               continue;
        	           }
        	         // dequeue from stnqueue
        	 		 tmp = stnque[stnfront];
        	 		 stnfront++;
        	 		 if(stnfront == 100)
        	 			 stnfront =0; // wrap arround
        	 		 if(stnfront == stnrear)
        	 			 isstnempty =1; //queue has been emptied
                     if(tmp == '\r' && flag==1)
                     {
                       // ignore first carriage return
                       // send_UART("SCR",1); //response debug
                       STNresponse[j] = '\0';
                       break;

                       // printf("Hit a carriage return BT\n");
                     }
                     else if(tmp == '\r')
        	         {
        	         //printf("Hit a terminate condition STN at i: %d\n", i);
                    	//send_UART("FCR",1); //response debug
                    	flag =1;
        	           j--;
        	         }
                     else if(tmp == '>')
                     {
                    	 STNresponse[j] = tmp;
                    	 STNresponse[j+1] = '\0';
                    	 break;// term condition?
                     }
        	         else
        	         {

        	           STNresponse[j] = tmp;
        	          //printf("Added: %c to STN at i: %d\n", STNresponse[i], i);
        	         }

        	         j++;
        	     }
        	     //printf("STN Response is: %s\n",STNresponse);
        	     if(strcmp((const unsigned char *)STNresponse, CARROT)==0)
        	     {
        	       // have to send OBDreq
        	       // just a test for now
        	      // printf("Sending OBDreq to STN\n");
        	       // carrot indicates STN is ready to receive a request
        	    	 // debug respons here
//        	    	 send_UART("FTCH", 1);
//        	    	 __delay_cycles(2000);
        	       send_UART(response, 0); // send OBD request to STN

        	       continue;

        	     }
        	     else if(strcmp((const unsigned char *)STNresponse, NODATA)==0)
        	     {
        	       // set some flag
        	      // printf("Something bad happened\n");
        	      send_UART("NODATA",1); //response debug
        	       break;
        	     }
        	     else if(strcmp((const unsigned char *)STNresponse, STOPPED)==0)
        	     {
        	       // set some flag
        	      // printf("Something bad happened\n");
        	       send_UART("E1",1); //response debug
        	       break;
        	     }
        	     else if(strcmp((const unsigned char *)STNresponse, OK)==0)
        	     {
        	       // set some flag
        	    	//send_UART("OK",1); //response debug
        	       continue;
        	     }
        	     else if(strcmp((const unsigned char *)STNresponse, POWER)==0)
        	     {
        	       // set some flag
        	    	//send_UART("OK",1); //response debug
        	       continue;
        	     }
        	     else if(strcmp((const unsigned char *)STNresponse, SEARCH)==0)
        	     {
        	       // set some flag
        	    	//send_UART("OK",1); //response debug
        	       continue;
        	     }
        	     else
        	     {
        	       // the actual PID response technically, so do nothing, STNresponse should now
        	       // have the PID response
        	       //  printf("response should have the PID response in STNresponse \n");
        	    	// send_UART("Else",1); //response debug
        	       break;

        	     }
        	   }

           send_UART(STNresponse, 1); // send OBD response over BT
           //send_UART("ok",1); //response debug
           continue;
         }

         // Never supposed to reach here, theoretically


      }// infinite firmware loop
}

//void reqSTN(volatile unsigned char* OBDreq)
//{
//
//  while(1)
//  {
//    while(isstnempty == 1)
//    {
//      // trap until a response is received
//    }
//    i=0;
//    while(1)
//    {
//        if(isstnempty == 1)
//          {
//              continue;
//          }
//        // dequeue from stnqueue
//		 tmp = stnque[stnfront];
//		 stnfront++;
//		 if(stnfront == 100)
//			 stnfront =0; // wrap arround
//		 if(stnfront == stnrear)
//			 isstnempty =1; //queue has been emptied
//        if(tmp == '\r')
//        {
//        //printf("Hit a terminate condition STN at i: %d\n", i);
//          STNresponse[i] = '\0';
//          break;
//        }
//        else
//        {
//
//          STNresponse[i] = tmp;
//         //printf("Added: %c to STN at i: %d\n", STNresponse[i], i);
//        }
//
//        i++;
//    }
//    //printf("STN Response is: %s\n",STNresponse);
//    if(strcmp((const unsigned char *)STNresponse, CARROT)==0)
//    {
//      // have to send OBDreq
//      // just a test for now
//     // printf("Sending OBDreq to STN\n");
//      // carrot indicates STN is ready to receive a request
//      send_UART(OBDreq, 0); // send OBD request to STN
//
//      continue;
//
//    }
//    else if(strcmp((const unsigned char *)STNresponse, NODATA)==0)
//    {
//      // set some flag
//     // printf("Something bad happened\n");
//     send_UART("NODATA",1); //response debug
//      break;
//    }
//    else if(strcmp((const unsigned char *)STNresponse, STOPPED)==0)
//    {
//      // set some flag
//     // printf("Something bad happened\n");
//      send_UART("E1",1); //response debug
//      break;
//    }
//    else if(strcmp((const unsigned char *)STNresponse, OK)==0)
//    {
//      // set some flag
//      continue;
//    }
//    else
//    {
//      // the actual PID response technically, so do nothing, STNresponse should now
//      // have the PID response
//      //  printf("response should have the PID response in STNresponse \n");
//      break;
//
//    }
//  }
//
//  return;
//}
